<template>

    <form action="#" @submit.prevent="store">
        <div class="columns">
            <div class="column is-10">
        <b-field horizontal label="Destinatário">

            <b-input type="text" v-model="form.name" />
        </b-field>
        </div>
        </div>
        <div class="columns">
            <div class="column is-10">
                <b-field horizontal label="Documento">
                <b-field grouped>
                    <b-select v-model="form.doc_type" id="docType" name="doc_type" data-checkout="docType" type="text"></b-select>
                    <b-input v-model="form.cpf_cnpj" v-mask="form.doc_type === 'CPF' ? '###.###.###-##' : '##.###.###/####-##'" :placeholder="form.doc_type === 'CPF' ? '000.000.000-00' : ''"></b-input>
                </b-field>
                </b-field>
            </div>
        </div>
        <div class="columns">
                <div class="column is-10">
                    <b-field horizontal label="CEP " :addons="false" class="field-cep">
                        <b-input
                            placeholder="Entre com o CEP"
                            v-model="form.postal_code"
                            v-mask="'##.###-###'"
                            @input.native="onInput"
                            class="is-cep"
                            @keyup.native="searchCep">
                        </b-input>
                    </b-field>
                </div>
        </div>
        <div class="columns">
            <div class="column is-offset-2 n-cep">
                <a href="http://www.buscacep.correios.com.br/sistemas/buscacep/" class="buscaCep" target="_blank">
                    não sei meu cep
                </a>
            </div>
        </div>
        <div v-if="onCompletedCep">
            <div class="columns">
                <div class="column is-10">
                    <b-field horizontal label="Endereço">
                        <b-input type="text" v-model="form.address_1" />
                    </b-field>
                    <b-field horizontal label="Número">
                        <b-input type="text" v-model="form.number" class="is-address-number" />
                    </b-field>
                    <b-field horizontal label="Complemento">
                        <b-input type="text" v-model="form.complement" />
                    </b-field>
                    <b-field horizontal label="Referência">
                        <b-input type="text" v-model="form.reference" />
                    </b-field>
                    <b-field horizontal label="Bairro">
                        <b-input type="text" v-model="form.address_2" />
                    </b-field>
                    <b-field horizontal label="Cidade">
                        <b-input type="text" v-model="form.city" />
                    </b-field>
                    <b-field horizontal label="Estado">
                        <b-input type="text" v-model="form.state" class="is-state" />
                    </b-field>
                    <b-field horizontal label="País">
                        <div class="select is-fullwidth">
                            <CountryDropdown v-model="form.country_id" />
                        </div>
                    </b-field>
                    </div>
                </div>
            </div>
            <div class="columns">
                <div class="column is-10">
                    <div class="buttons">
                        <b-button type="is-link" v-if="form.postal_code" @click="store">Adicionar</b-button>
                        <b-button @click="$emit('cancel')">Cancelar</b-button>
                    </div>
                </div>
            </div>
    </form>
</template>
<script>
import CountryDropdown from '@/components/form/CountryDropdown'

export default {

    components: {
        CountryDropdown
    },

    data() {
        return {
            cep: '',
            rawCep: '',
            dataAddress: [],
            masks: {
                maskCep: {
                    delimiters: ['.', '-'],
                    blocks: [2, 3, 3],
                    numericOnly: true
                }
            },
            form: {
                name: '',
                doc_type: 'CPF',
                cpf_cnpj: null,
                address_1: '',
                address_2: '',
                number: '',
                complement: '',
                reference: '',
                city: '',
                state: '',
                postal_code: '',
                country_id: 30,
                default: true
            }
        }
    },

    methods: {
        onInput(event){
            this.cep = this.unmasked(event.target.value)
            localStorage.cep = this.unmasked(event.target.value)
        },
        unmasked(value) {
            var output = value.replace(new RegExp(/[^\d]/, 'g'), '');
            return output
        },

        async store(){
            console.log(this.form)
            let response = await this.$axios.$post('/api/addresses', this.form)

            this.$emit('created', response.data)
        },


        searchCep (event) {
            let cep = this.unmasked(event.target.value)

			if(cep.length === 8) {
				this.$axios.$get(`/consultacep/${ cep }/json/`)
				.then( response => {
                    this.form.address_1 = response.logradouro
                    this.form.address_2 = response.bairro
                    this.form.city = response.localidade
                    this.form.state = response.uf
                    this.form.country_id = 30
                    // this.dataAddress = response
                })
				.catch( error => console.log(error) )
			}
		}
    },

    computed: {
        onCompletedCep() {
            return this.cep.length === 8
        }
    },

    mounted(){
        window.Mercadopago.getIdentificationTypes();
    }

}
</script>

<style>
    .buttons {
        margin-top: 10px;
    }

    .is-address-number {
        width: 15rem;
    }

    .is-state {
        width: 15rem;
    }

    .n-cep {
        margin-top: -1rem;
    }

    .is-cep {
        /* padding-left: 10px; */
        width: 15rem;
    }
</style>
